=== debian/changelog ===
deepin-modelhub (0.0.10-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 13 Jun 2024 09:58:36 +0800

deepin-modelhub (0.0.11) unstable; urgency=medium

  * update deepin modelhub baseline version to V0.0.11

 -- zhangyu <zhangyub@uniontech.com>  Mon, 3 Jun 2024 13:51:22 +0800

deepin-modelhub (0.0.10) unstable; urgency=medium

  * update deepin modelhub baseline version to V0.0.10

 -- zhangyu <zhangyub@uniontech.com>  Fri, 24 May 2024 11:14:12 +0800

deepin-modelhub (0.0.1) unstable; urgency=medium

  * update deepin modelhub baseline version to V0.0.1

 -- zhangyu <zhangyub@uniontech.com>  Tue, 7 May 2024 11:10:24 +0800
