=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export QT_SELECT = 5

%:
	dh $@ --parallel

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_configure:
	dh_auto_configure -- VERSION=$(VERSION) "-DVERSION=$(DEB_VERSION_UPSTREAM)" \
	 -DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release
	
override_dh_auto_build:
	dh_auto_build -- -j8
